# Galaxy simulator

## Description

This project implements a solar system model consisting of three planets. Depending on the
planets position relative to the sun and to each other, some specific weather condition can be 
triggered:

- A DRY condition is triggered when the sun and all planets are aligned;
- An OPTIMAL condition is triggered if the planets are aligned, but not with the sun;
- A RAINY condition is triggered if the sun is within the triangle formed between the planets.

For the RAIN condition, its peak is determined by the highest triangle perimeter.

## Deployment

The application is deployed at <https://ml-galaxy-app.herokuapp.com>, and a REST api is provided
for interacting with it. The database is hosted at Mongo Atlas, in a sandbox free tier cluster.

## REST api endpoints

#### `POST /weather`

Body content:

```json
{
    "years": 10,
    "planets": [
        {
            "name": "Ferengi",
            "kilometersFromSun": 500,
            "degreesPerDay": 1,
            "orbitDirection": "CLOCKWISE"
        },
        {
            "name": "Vulcano",
            "kilometersFromSun": 1000,
            "degreesPerDay": 5,
            "orbitDirection": "COUNTER_CLOCKWISE"
        },
        {
            "name": "Betasoide",
            "kilometersFromSun": 2000,
            "degreesPerDay": 3,
            "orbitDirection": "CLOCKWISE"
        }
    ]
}
```

Creates a job to generate the weather summary and calendar for the following N years,
according to the planets specifications. The specifications are optional, and if omitted,
the default values above will be used.

Returns a job id for getting the results afterwards.

#### `GET /weather/summary/{years}`

Returns the summary results for N years, containing the number of periods for each weather
condition, and the days when the rain condition reaches its peak. Optionally, a jobId can
be passed as a query param, to get the summary generated by a specific job.

#### `GET /weather/days/{dayNumber}`

Returns the weather condition for a specific day. Optionally, a jobId can be passed as a 
query param, to get the day weather generated by a specific job.

#### `GET /weather/test?years={years}`

Calculates (synchronously) and returns the summary for the next N years using the default
planets specification. If years are not specified, the default value will be 10.
Used only for testing purposes.